'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Radio = exports.RadioGroup = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _unstated = require('unstated');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Container
// ------------------------------

var RadioContainer = function (_Container) {
  _inherits(RadioContainer, _Container);

  function RadioContainer(props) {
    _classCallCheck(this, RadioContainer);

    var _this = _possibleConstructorReturn(this, (RadioContainer.__proto__ || Object.getPrototypeOf(RadioContainer)).call(this, props));

    _this.getName = function () {
      return _this.name;
    };

    _this.onChange = function (event) {
      var value = event.target.value;


      _this.setState({ value: value });

      if (_this.consumerOnChange) _this.consumerOnChange(value);
    };

    _this.consumerOnChange = props.onChange;
    _this.name = props.name;

    _this.state = { value: props.value };
    return _this;
  }

  return RadioContainer;
}(_unstated.Container);

// Group
// ------------------------------

exports.default = RadioContainer;
var RadioGroup = function RadioGroup(_ref) {
  var children = _ref.children,
      props = _objectWithoutProperties(_ref, ['children']);

  var container = new RadioContainer(props);
  return _react2.default.createElement(
    _unstated.Provider,
    { inject: [container] },
    children
  );
};

// Radio
// ------------------------------

exports.RadioGroup = RadioGroup;

var Radio = exports.Radio = function (_Component) {
  _inherits(Radio, _Component);

  function Radio() {
    _classCallCheck(this, Radio);

    return _possibleConstructorReturn(this, (Radio.__proto__ || Object.getPrototypeOf(Radio)).apply(this, arguments));
  }

  _createClass(Radio, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          Component = _props.Component,
          innerRef = _props.innerRef,
          props = _objectWithoutProperties(_props, ['Component', 'innerRef']);

      return _react2.default.createElement(
        _unstated.Subscribe,
        { to: [RadioContainer] },
        function (_ref2) {
          var getName = _ref2.getName,
              onChange = _ref2.onChange,
              state = _ref2.state;

          var checked = state.value === props.value;

          return _react2.default.createElement(Component, _extends({}, props, {
            checked: checked,
            name: getName(),
            onChange: onChange,
            ref: innerRef,
            type: 'radio'
          }));
        }
      );
    }
  }]);

  return Radio;
}(_react.Component);

Radio.defaultProps = {
  Component: 'input'
};